> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Users With Messages

> Users With Messages — CometChat documentation.

## Overview

The UsersWithMessages is a [Composite Component](/ui-kit/react/v4/components-overview#components) encompassing components such as [Users](/ui-kit/react/v4/users) and [Messages](/ui-kit/react/v4/messages). Both of these component contributes to the functionality and structure of the overall UsersWithMessages component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/7240796d-users_with_messages_overview_web_screens-6bac9ffd887a4fc9e712f7aca384006c.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=e09b7cc13deaae861d21e1321e39439f" width="3675" height="2400" data-path="images/7240796d-users_with_messages_overview_web_screens-6bac9ffd887a4fc9e712f7aca384006c.png" />
</Frame>

| Components                            | Description                                                                                                                  |
| ------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------- |
| [Users](/ui-kit/react/v4/users)       | The `Users` component is designed to display a list of `User`. This essentially represents your recent conversation history. |
| [Messages](/ui-kit/react/v4/messages) | The `Messages` component is designed to manage the messaging interaction for individual `User's` conversations.              |

## Usage

### Integration

<Tabs>
  <Tab title="UsersWithMessagesDemo.tsx">
    ```typescript theme={null}
    import { CometChatUsersWithMessages } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      return <CometChatUsersWithMessages />;
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="App.tsx">
    ```typescript theme={null}
    import UsersWithMessagesDemo from "./UsersWithMessagesDemo";

    export default function App() {
      return (
        <div className="App">
          <UsersWithMessagesDemo />
        </div>
      );
    }
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/ui-kit/react/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

#### 1. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the UserWithMessages component.

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChatUsersWithMessages } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const handleOnError = () => {
        console.log("Your custom on error actions");
      };

      return <CometChatUsersWithMessages onError={handleOnError} />;
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChatUsersWithMessages } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const handleOnError = () => {
        console.log("Your custom on error actions");
      };

      return <CometChatUsersWithMessages onError={handleOnError} />;
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

The UsersWithMessages component does not have much actions, its components - [Users](/ui-kit/react/v4/users) and [Messages](/ui-kit/react/v4/messages) - both have their own set of actions.

The Action of the components can be overridden through the use of the [Configurations](#configurations) object of its components. Here is an example code snippet.

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import {
      CometChatUsersWithMessages,
      MessageHeaderConfiguration,
      MessagesConfiguration,
      UsersConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      function handleOnItemClick(user: CometChat.User): void {
        console.log(user, "your custom on item click action");
      }
      function handleOnBack() {
        console.log("your custom on back action");
      }
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              onItemClick: handleOnItemClick,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              messageHeaderConfiguration: new MessageHeaderConfiguration({
                onBack: handleOnBack,
              }),
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import {
      CometChatUsersWithMessages,
      MessageHeaderConfiguration,
      MessagesConfiguration,
      UsersConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      function handleOnItemClick(user) {
        console.log(user, "your custom on item click action");
      }

      function handleOnBack() {
        console.log("your custom on back action");
      }

      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              onItemClick: handleOnItemClick,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              messageHeaderConfiguration: new MessageHeaderConfiguration({
                onBack: handleOnBack,
              }),
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

The UsersWithMessages component overrides several actions from its components to reach its default behavior. The list of actions overridden by UsersWithMessages includes:

* [OnItemClick](/ui-kit/react/v4/users#2-onitemclick) : By overriding the `OnItemClick` of the Users Component, UsersWithMessages achieves navigation from [Users](/ui-kit/react/v4/users) to [Messages](/ui-kit/react/v4/messages) component.

  <Frame>
    <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d0f6711c-users_with_messages_onitemclick_web_screens-a2bdda9009f1a50a6c1ad7fc332b81cd.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=aed9e9fcd3e0bfce5c07eb7fcc67de2c" width="3676" height="2400" data-path="images/d0f6711c-users_with_messages_onitemclick_web_screens-a2bdda9009f1a50a6c1ad7fc332b81cd.png" />
  </Frame>

  ### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

While the UsersWithMessages component does not have filters, its components do, For more detail on individual filters of its component refer to [Users Filters](/ui-kit/react/v4/users#filters) and [Messages Filters](/ui-kit/react/v4/messages#filters).

By utilizing the [Configurations](#configurations) object of its components, you can apply filters.

In the following **example**, we're sorting `Users` by name and setting the limit to 10 using the `usersRequestBuilder`.

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      UsersConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              onItemClick: handleOnItemClick,
              usersRequestBuilder: new CometChat.UsersRequestBuilder()
                .sortBy("name")
                .setLimit(10),
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      UsersConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              onItemClick: handleOnItemClick,
              usersRequestBuilder: new CometChat.UsersRequestBuilder()
                .sortBy("name")
                .setLimit(10),
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/ui-kit/react/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The UsersWithMessages does not produce any events but its component does.

***

## Customization

To fit your app's design requirements, you have the ability to customize the appearance of the UsersWithMessages component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

#### 1. UsersWithMessages Style

You can set the `UsersWithMessagesStyle` to the UsersWithMessages Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/udim9ku6wPsRNXGs/images/df1bf2b6-users_with_messages_style_web_screens-e06b12ab13821ebbc530da7b9be1b61e.png?fit=max&auto=format&n=udim9ku6wPsRNXGs&q=85&s=ad0064df8a63a0488456ed07f9adddfe" width="3676" height="2400" data-path="images/df1bf2b6-users_with_messages_style_web_screens-e06b12ab13821ebbc530da7b9be1b61e.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import {
      CometChatUsersWithMessages,
      WithMessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const usersWithMessagesStyle = new WithMessagesStyle({
        background: "#e2d6ff",
        messageTextColor: "#000000",
        borderRadius: "12px",
      });
      return (
        <CometChatUsersWithMessages
          usersWithMessagesStyle={usersWithMessagesStyle}
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import {
      CometChatUsersWithMessages,
      WithMessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const usersWithMessagesStyle = new WithMessagesStyle({
        background: "#e2d6ff",
        messageTextColor: "#000000",
        borderRadius: "12px",
      });
      return (
        <CometChatUsersWithMessages
          usersWithMessagesStyle={usersWithMessagesStyle}
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

You can also customize its component styles. For more details on individual component styles, you can refer [Users Styles](/ui-kit/react/v4/users#style) and [Messages Styles](/ui-kit/react/v4/messages#1-messages-style).

Styles can be applied to SubComponents using their respective [configurations](#configurations).

**Example**

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import {
      CometChatUsersWithMessages,
      UsersStyle,
      MessagesStyle,
      UsersConfiguration,
      MessagesConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const usersStyle = new UsersStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      const messagesStyle = new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "3px solid #cb1fff",
        background: "linear-gradient(#885df5, #d396ff, #e497f0, #dd20fa)",
      });
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              usersStyle: usersStyle,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              messagesStyle: messagesStyle,
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import {
      CometChatUsersWithMessages,
      UsersStyle,
      MessagesStyle,
      UsersConfiguration,
      MessagesConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const usersStyle = new UsersStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      const messagesStyle = new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "3px solid #cb1fff",
        background: "linear-gradient(#885df5, #d396ff, #e497f0, #dd20fa)",
      });
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              usersStyle: usersStyle,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              messagesStyle: messagesStyle,
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of **small functional customizations** that allow you to **fine-tune** the overall experience of the component. With these, you can **change text**, set **custom icons**, and toggle the **visibility** of UI elements.

you can utilize the `user` method with a [User](/sdk/javascript/user-management) object as input to the UsersWithMessages component. This will automatically direct you to the [Messages](/ui-kit/react/v4/messages) component for the specified `User`.

#### user

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsersWithMessages } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const [chatUser, setChatUser] = React.useState<CometChat.User>();
      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
          setChatUser(user);
        });
      }, []);
      return <CometChatUsersWithMessages user={chatUser} />;
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsersWithMessages } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const UsersWithMessagesDemo = () => {
      const [chatUser, setChatUser] = useState(null);

      useEffect(() => {
        CometChat.getUser("uid").then((user) => {
          setChatUser(user);
        });
      }, []);

      return <CometChatUsersWithMessages user={chatUser} />;
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

Below is a list of customizations along with corresponding code snippets:

| Property         | Description                                                                                                                                                | Code                                     |
| ---------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------- |
| **isMobileView** | A boolean indicating if the component should render in mobile view for optimized display on mobile devices.                                                | `isMobileView: false`                    |
| **user**         | Use the user method with a User object as input for the UsersWithMessages component to navigate directly to the Messages component for the specified User. | `user={chatUser}`                        |
| **messageText**  | It represents the textual content which will be replaced with the messages component when user clicks on a particular user chat.                           | `messageText="Your Custom Message Text"` |

***

#### Components

Nearly all functionality customizations available for a Component are also available for the composite component. Using [Configuration](#configurations), you can modify the properties of its components to suit your needs.

You can find the list of all Functionality customization of individual components in [Users](/ui-kit/react/v4/users#functionality) and [Messages](/ui-kit/react/v4/messages#functionality).

**Example**

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      UsersConfiguration,
      MessagesConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              hideSearch: true,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              disableTyping: true,
              hideMessageHeader: true,
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      UsersConfiguration,
      MessagesConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              hideSearch: true,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              disableTyping: true,
              hideMessageHeader: true,
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your own views, layouts, and UI elements and then incorporate those into the component.

By utilizing the [Configuration](#configurations) object of each component, you can apply advanced-level customizations to the UsersWithMessages.

**Example**

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      UsersConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              errorStateView: getErrorStateView(),
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      UsersConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              errorStateView: getErrorStateView(),
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

To find all the details on individual Component advance customization you can refer, [Users Advance](/ui-kit/react/v4/users#advance)and [Messages Advance](/ui-kit/react/v4/messages#advanced).

UsersWithMessages uses advanced-level customization of both Users & Messages components to achieve its default behavior.

1. UsersWithMessages utilizes the [onItemClick](/ui-kit/react/v4/users#2-onitemclick) property of the `Users` subcomponent to navigate the user from [Users](/ui-kit/react/v4/users) to [Messages](/ui-kit/react/v4/messages)

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d0f6711c-users_with_messages_onitemclick_web_screens-a2bdda9009f1a50a6c1ad7fc332b81cd.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=aed9e9fcd3e0bfce5c07eb7fcc67de2c" width="3676" height="2400" data-path="images/d0f6711c-users_with_messages_onitemclick_web_screens-a2bdda9009f1a50a6c1ad7fc332b81cd.png" />
</Frame>

2. UsersWithMessages utilizes the [menus](/ui-kit/react/v4/messages#auxiliarymenu) of the `Messages` subcomponent to navigate from [Messages](/ui-kit/react/v4/messages) to [Details](/ui-kit/react/v4/group-details)

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bKHmaxDqzaJZWwLS/images/469ee1af-users_with_messages_advance_web_screens-badf9ddc8cb55e0a04d7b6459a29277c.png?fit=max&auto=format&n=bKHmaxDqzaJZWwLS&q=85&s=fd5f5c4163b9c1c539c5d58924b737ea" width="3675" height="2400" data-path="images/469ee1af-users_with_messages_advance_web_screens-badf9ddc8cb55e0a04d7b6459a29277c.png" />
</Frame>

<Warning>
  When you override `onItemClick` and `menus`, the default behavior of UsersWithMessages will also be overridden.
</Warning>

## Configurations

[Configurations](/ui-kit/react/v4/components-overview#configurations) offer the ability to customize the properties of each component within a Composite Component.

UsersWithMessages has `Users` and `Messages` component. Hence, each of these components will have its individual \`Configuration\`\`.

* `Configurations` expose properties that are available in its individual components.

#### Users

You can customize the properties of the Users component by making use of the `usersConfiguration`. You can accomplish this by employing the `usersConfiguration` props as demonstrated below:

<Tabs>
  <Tab title="TypeScript">
    ```typescript theme={null}
     usersConfiguration={new UsersConfiguration({
      //override properties of users
      })}
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
     usersConfiguration={new UsersConfiguration({
      //override properties of users
      })}
    ```
  </Tab>
</Tabs>

All exposed properties of `UsersConfiguration` can be found under [Users](/ui-kit/react/v4/users#functionality). Properties marked with the [report]() symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Users subcomponent and, in addition, you only want to display five users sort by name.

You can modify the style using the `usersStyle` property and filter the list with the `usersRequestBuilder` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/oaJbJ0bOxG69pJ1L/images/87eb0774-users_with_messages_users_configuration_web_screens-13335c5bc4b74cf19ceaa75f71222f62.png?fit=max&auto=format&n=oaJbJ0bOxG69pJ1L&q=85&s=00c00dc6ee242e3318c3981c30c58b8b" width="3675" height="2400" data-path="images/87eb0774-users_with_messages_users_configuration_web_screens-13335c5bc4b74cf19ceaa75f71222f62.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      UsersConfiguration,
      UsersStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const usersStyle = new UsersStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              usersRequestBuilder: new CometChat.UsersRequestBuilder()
                .sortBy("name")
                .setLimit(5),
              usersStyle: usersStyle,
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      UsersConfiguration,
      UsersStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const usersStyle = new UsersStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      return (
        <CometChatUsersWithMessages
          usersConfiguration={
            new UsersConfiguration({
              usersRequestBuilder: new CometChat.UsersRequestBuilder()
                .sortBy("name")
                .setLimit(5),
              usersStyle: usersStyle,
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

#### Messages

You can customize the properties of the Messages component by making use of the messagesConfiguration. You can accomplish this by employing the `messagesConfiguration` props as demonstrated below:

<Tabs>
  <Tab title="TypeScript">
    ```typescript theme={null}
      messagesConfiguration={new MessagesConfiguration({
      //override properties of messages
      })}
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
     messagesConfiguration={new MessagesConfiguration({
      //override properties of messages
      })}
    ```
  </Tab>
</Tabs>

All exposed properties of `MessagesConfiguration` can be found under [Messages](/ui-kit/react/v4/messages#configuration). Properties marked with the [report]() symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Messages subcomponent and, in addition, you only want to hide message header.

You can modify the style using the `messagesStyle` property and hide the message header with the `hideMessageHeader` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/T-kVUXtubs0NtFU5/images/cfabd504-users_with_messages_messages_configuration_web_screens-be7c7988a750aebdd735ff2b3c156a31.png?fit=max&auto=format&n=T-kVUXtubs0NtFU5&q=85&s=480b24787cbffb55baab27282a22d013" width="3676" height="2400" data-path="images/cfabd504-users_with_messages_messages_configuration_web_screens-be7c7988a750aebdd735ff2b3c156a31.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      MessagesConfiguration,
      MessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const messagesStyle = new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      return (
        <CometChatUsersWithMessages
          messagesConfiguration={
            new MessagesConfiguration({
              hideMessageHeader: true,
              messagesStyle: messagesStyle,
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatUsersWithMessages,
      MessagesConfiguration,
      MessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const UsersWithMessagesDemo = () => {
      const messagesStyle = new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
        messageTextColor: "yellow",
      });
      return (
        <CometChatUsersWithMessages
          messagesConfiguration={
            new MessagesConfiguration({
              hideMessageHeader: true,
              messagesStyle: messagesStyle,
            })
          }
        />
      );
    };

    export default UsersWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Users With Messages

> Users With Messages — CometChat documentation.

## Overview

The UsersWithMessages is a [Composite Component](/docs/ui-kit/angular/v4/components-overview#components) encompassing components such as [Users](/docs/ui-kit/angular/v4/users) and [Messages](/docs/ui-kit/angular/v4/messages). Both of these component contributes to the functionality and structure of the overall UsersWithMessages component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/7240796d-users_with_messages_overview_web_screens-6bac9ffd887a4fc9e712f7aca384006c.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=e09b7cc13deaae861d21e1321e39439f" width="3675" height="2400" data-path="images/7240796d-users_with_messages_overview_web_screens-6bac9ffd887a4fc9e712f7aca384006c.png" />
</Frame>

| Components                              | Description                                                                                                                  |
| --------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------- |
| [Users](/docs/ui-kit/angular/v4/users)       | The `Users` component is designed to display a list of `User`. This essentially represents your recent conversation history. |
| [Messages](/docs/ui-kit/angular/v4/messages) | The `Messages` component is designed to manage the messaging interaction for individual `User's` conversations.              |

## Usage

### Integration

<Tabs>
  <Tab title="app.module.ts">
    ```ts theme={null}
    import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from "@angular/core";
    import { BrowserModule } from "@angular/platform-browser";
    import { CometChatUsersWithMessages } from "@cometchat/chat-uikit-angular";
    import { AppComponent } from "./app.component";

    @NgModule({
      imports: [BrowserModule, CometChatUsersWithMessages],
      declarations: [AppComponent],
      providers: [],
      bootstrap: [AppComponent],
      schemas: [CUSTOM_ELEMENTS_SCHEMA],
    })
    export class AppModule {}
    ```
  </Tab>

  <Tab title="app.component.ts">
    ```ts theme={null}
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {

      }

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-message></cometchat-users-with-message>
    </div>
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/docs/ui-kit/angular/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

##### 1. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the UserWithMessages component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      public handleOnError = (error: CometChat.CometChatException) => {
        console.log("your custom on error action", error);
      };
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [onError]="handleOnError"
      ></cometchat-users-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

The UsersWithMessages component does not have much actions, its components - [Users](/docs/ui-kit/angular/v4/users) and [Messages](/docs/ui-kit/angular/v4/messages) - both have their own set of actions.

The Action of the components can be overridden through the use of the [Configurations](#configurations) object of its components. Here is an example code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { UsersConfiguration, MessagesConfiguration, MessageHeaderConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public handleOnItemClickUser = (user: CometChat.User) => {
        console.log("your custom on item click action", user);
      };
      public handleOnBack = () => {
        console.log("Your custom on back action");
      }
      public usersConfiguration = new UsersConfiguration({
        onItemClick: this.handleOnItemClickUser
      });
      public messagesConfiguration = new MessagesConfiguration({
        messageHeaderConfiguration: new MessageHeaderConfiguration({
          onBack:this.handleOnBack
        })
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [usersConfiguration]="usersConfiguration"
        [messagesConfiguration]="messagesConfiguration"
      ></cometchat-users-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

The UsersWithMessages component overrides several actions from its components to reach its default behavior. The list of actions overridden by UsersWithMessages includes:

* [OnItemClick](/docs/ui-kit/angular/v4/users#2-onitemclick) : By overriding the `OnItemClick` of the Users Component, UsersWithMessages achieves navigation from [Users](/docs/ui-kit/angular/v4/users) to [Messages](/docs/ui-kit/angular/v4/messages) component.

  <Frame>
    <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d0f6711c-users_with_messages_onitemclick_web_screens-a2bdda9009f1a50a6c1ad7fc332b81cd.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=aed9e9fcd3e0bfce5c07eb7fcc67de2c" width="3676" height="2400" data-path="images/d0f6711c-users_with_messages_onitemclick_web_screens-a2bdda9009f1a50a6c1ad7fc332b81cd.png" />
  </Frame>

  ### Fliters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

While the UsersWithMessages component does not have filters, its components do, For more detail on individual filters of its component refer to [Users Filters](/docs/ui-kit/angular/v4/users#filters) and [Messages Filters](/docs/ui-kit/angular/v4/messages).

By utilizing the [Configurations](#configurations) object of its components, you can apply filters.

In the following **example**, we're sorting `Users` by name and setting the limit to 10 using the `usersRequestBuilder`.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { UsersConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public usersConfiguration = new UsersConfiguration({
        usersRequestBuilder: new CometChat.UsersRequestBuilder().sortBy("name").setLimit(10)
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [usersConfiguration]="usersConfiguration"
      ></cometchat-users-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/docs/ui-kit/angular/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The UsersWithMessages does not produce any events but its component does.

***

## Customization

To fit your app's design requirements, you have the ability to customize the appearance of the UsersWithMessages component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

##### 1. UsersWithMessages Style

You can set the `UsersWithMessagesStyle` to the UsersWithMessages Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/udim9ku6wPsRNXGs/images/df1bf2b6-users_with_messages_style_web_screens-e06b12ab13821ebbc530da7b9be1b61e.png?fit=max&auto=format&n=udim9ku6wPsRNXGs&q=85&s=ad0064df8a63a0488456ed07f9adddfe" width="3676" height="2400" data-path="images/df1bf2b6-users_with_messages_style_web_screens-e06b12ab13821ebbc530da7b9be1b61e.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { WithMessagesStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      usersWithMessagesStyle = new WithMessagesStyle({
        background: "#e2d6ff",
        messageTextColor: "#000000",
        borderRadius: "12px",
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [usersWithMessagesStyle]="usersWithMessagesStyle"
      ></cometchat-users-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

You can also customize its component styles. For more details on individual component styles, you can refer [Users Styles](/docs/ui-kit/angular/v4/users#style) and [Messages Styles](/docs/ui-kit/angular/v4/messages#1-messages-style).

Styles can be applied to SubComponents using their respective [configurations](#configurations).

**Example**

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { UsersConfiguration, MessagesConfiguration, UsersStyle, MessagesStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      usersStyle = new UsersStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      public usersConfiguration = new UsersConfiguration({
        usersStyle:this.usersStyle
      });
      public messagesConfiguration = new MessagesConfiguration({
        messagesStyle: new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "3px solid #cb1fff",
        background: "linear-gradient(#885df5, #d396ff, #e497f0, #dd20fa)",
        }),
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [usersConfiguration]="usersConfiguration"
        [messagesConfiguration]="messagesConfiguration"
      ></cometchat-users-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of **small functional customizations** that allow you to **fine-tune** the overall experience of the component. With these, you can **change text**, set **custom icons**, and toggle the **visibility** of UI elements.

you can utilize the `user` method with a [User](/docs/sdk/javascript/user-management) object as input to the UsersWithMessages component. This will automatically direct you to the [Messages](/docs/ui-kit/angular/v4/messages) component for the specified `User`.

##### user

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public userObject!: CometChat.User;

      ngOnInit(): void {
        CometChat.getUser("uid").then((user: CometChat.User) => {
          this.userObject = user;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [user]="userObject"
      ></cometchat-users-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

Below is a list of customizations along with corresponding code snippets:

| Property         | Description                                                                                                                                                | Code                    |
| ---------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------- |
| **isMobileView** | A boolean indicating if the component should render in mobile view for optimized display on mobile devices.                                                | `[isMobileView]= false` |
| **user**         | Use the user method with a User object as input for the UsersWithMessages component to navigate directly to the Messages component for the specified User. | `[user]="userObject"`   |
| **messageText**  | It represents the textual content which will be replaced with the messages component when user clicks on a particular user chat.                           | `[messageText]="text"`  |

***

##### Components

Nearly all functionality customizations available for a Component are also available for the composite component. Using [Configuration](#configurations), you can modify the properties of its components to suit your needs.

You can find the list of all Functionality customization of individual components in [Users](/docs/ui-kit/angular/v4/users#functionality) and [Messages](/docs/ui-kit/angular/v4/messages#functionality).

**Example**

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { UsersConfiguration, MessagesConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public usersConfiguration = new UsersConfiguration({
        hideSearch:true
      });
      public messagesConfiguration = new MessagesConfiguration({
        disableTyping: true,
        hideMessageHeader: true,
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [usersConfiguration]="usersConfiguration"
        [messagesConfiguration]="messagesConfiguration"
      ></cometchat-users-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your own views, layouts, and UI elements and then incorporate those into the component.

By utilizing the [Configuration](#configurations) object of each component, you can apply advanced-level customizations to the UsersWithMessages.

**Example**

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit, TemplateRef, ViewChild } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { UsersConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public usersConfiguration!: UsersConfiguration;
      ngOnInit(): void {
        this.usersConfiguration= new UsersConfiguration({
          errorStateView:this.errorStateView,
        });
      }
      @ViewChild('errorStateView', { static: true }) errorStateView!: TemplateRef<any>;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [usersConfiguration]="usersConfiguration"
      ></cometchat-users-with-messages>
    </div>
    <ng-template #errorStateView>
      <div style="height: 100vh; width: 100vw">
        <img
          src="icon"
          alt="error icon"
          style="height:100px; width: 100px; justify-content: center; margin-top: 250px; margin-right: 700px;"
        />
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

To find all the details on individual Component advance customization you can refer, [Users Advance](/docs/ui-kit/angular/v4/users#advance)and [Messages Advance](/docs/ui-kit/angular/v4/messages#advanced).

UsersWithMessages uses advanced-level customization of both Users & Messages components to achieve its default behavior.

1. UsersWithMessages utilizes the [onItemClick](/docs/ui-kit/angular/v4/users#2-onitemclick) property of the `Users` subcomponent to navigate the user from [Users](/docs/ui-kit/angular/v4/users) to [Messages](/docs/ui-kit/angular/v4/messages)

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d0f6711c-users_with_messages_onitemclick_web_screens-a2bdda9009f1a50a6c1ad7fc332b81cd.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=aed9e9fcd3e0bfce5c07eb7fcc67de2c" width="3676" height="2400" data-path="images/d0f6711c-users_with_messages_onitemclick_web_screens-a2bdda9009f1a50a6c1ad7fc332b81cd.png" />
</Frame>

2. UsersWithMessages utilizes the [menus](/docs/ui-kit/angular/v4/messages#auxiliarymenu) of the `Messages` subcomponent to navigate from [Messages](/docs/ui-kit/angular/v4/messages) to [Details](/docs/ui-kit/angular/v4/group-details)

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bKHmaxDqzaJZWwLS/images/469ee1af-users_with_messages_advance_web_screens-badf9ddc8cb55e0a04d7b6459a29277c.png?fit=max&auto=format&n=bKHmaxDqzaJZWwLS&q=85&s=fd5f5c4163b9c1c539c5d58924b737ea" width="3675" height="2400" data-path="images/469ee1af-users_with_messages_advance_web_screens-badf9ddc8cb55e0a04d7b6459a29277c.png" />
</Frame>

<Warning>
  When you override `onItemClick` and `menus`, the default behavior of UsersWithMessages will also be overridden.
</Warning>

## Configurations

[Configurations](/docs/ui-kit/angular/v4/components-overview#configurations) offer the ability to customize the properties of each component within a Composite Component.

UsersWithMessages has `Users` and `Messages` component. Hence, each of these components will have its individual \`Configuration\`\`.

* `Configurations` expose properties that are available in its individual components.

#### Users

You can customize the properties of the Users component by making use of the `usersConfiguration`.

All exposed properties of `UsersConfiguration` can be found under [Users](/docs/ui-kit/angular/v4/users#functionality). Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Users subcomponent and, in addition, you only want to display five users sort by name.

You can modify the style using the `usersStyle` property and filter the list with the `usersRequestBuilder` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/oaJbJ0bOxG69pJ1L/images/87eb0774-users_with_messages_users_configuration_web_screens-13335c5bc4b74cf19ceaa75f71222f62.png?fit=max&auto=format&n=oaJbJ0bOxG69pJ1L&q=85&s=00c00dc6ee242e3318c3981c30c58b8b" width="3675" height="2400" data-path="images/87eb0774-users_with_messages_users_configuration_web_screens-13335c5bc4b74cf19ceaa75f71222f62.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { UsersConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public usersConfiguration!: UsersConfiguration;
      ngOnInit(): void {
        this.usersConfiguration= new UsersConfiguration({
          usersRequestBuilder: new CometChat.UsersRequestBuilder().sortBy("name").setLimit(5),
          usersStyle:this.usersStyle,
        });
      }
      usersStyle = new UsersStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [usersConfiguration]="usersConfiguration"
      ></cometchat-users-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

#### Messages

You can customize the properties of the Messages component by making use of the messagesConfiguration.

All exposed properties of `MessagesConfiguration` can be found under [Messages](/docs/ui-kit/angular/v4/messages#configuration). Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Messages subcomponent and, in addition, you only want to hide message header.

You can modify the style using the `messagesStyle` property and hide the message header with the `hideMessageHeader` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/T-kVUXtubs0NtFU5/images/cfabd504-users_with_messages_messages_configuration_web_screens-be7c7988a750aebdd735ff2b3c156a31.png?fit=max&auto=format&n=T-kVUXtubs0NtFU5&q=85&s=480b24787cbffb55baab27282a22d013" width="3676" height="2400" data-path="images/cfabd504-users_with_messages_messages_configuration_web_screens-be7c7988a750aebdd735ff2b3c156a31.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { MessagesConfiguration, MessagesStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public messagesConfiguration = new MessagesConfiguration({
        hideMessageHeader: true,
        messagesStyle: new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "3px solid #cb1fff",
        background: "linear-gradient(#885df5, #d396ff, #e497f0, #dd20fa)",
        }),
      });

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users-with-messages
        [messagesConfiguration]="messagesConfiguration"
      ></cometchat-users-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***
